#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
 * Loetakse failist rida eripikkuseid stringe koos järjekorra numbriga, 
 * mis tuleb printida teise faili tagurpidi (kasutades ümbepööramiseks stacki).
 * Stacki element tuleb peale lugemist hävitada
 * */

const char INPUTFILENAME[] = "data.in";

typedef struct NODE {
    int id;
    int dat;
    char *name;
}NODE;

typedef struct STACK{
    NODE *dat;
    struct STACK *pNext;
}STACK;

int file_check(FILE*);
STACK *read_file(FILE*);
int isempty(STACK*);
NODE *pop(STACK*);
STACK *push(STACK*, NODE*);
void read_all(STACK*);

int main(void){
    FILE *F = fopen(INPUTFILENAME, "r");
    if(!file_check(F)){
        printf("File %s not found\n", INPUTFILENAME);
        return 1;
    }
    STACK *stack = read_file(F);
    if(isempty(stack)){
        printf("Stack is empty\n");
        return 2;
    }
    read_all(stack);
    return 0;
}

int file_check(FILE *F){
    if(F != NULL)
        return 1;
    return 0;
}

STACK *read_file(FILE *F){
    STACK *stackTop = NULL;
    int buf1, buf2;
    char bufstr[256];
    while(fscanf(F, "%d %d %s", &buf1, &buf2, bufstr) != EOF){
        NODE *newNode = (NODE*)malloc(sizeof(NODE));
        newNode->id = buf1;
        newNode->dat = buf2;
        int len = strlen(bufstr);
        newNode->name = malloc(sizeof(char)*len);
        strcpy(newNode->name, bufstr);
        stackTop = push(stackTop, newNode);
    }
    return stackTop;
}

int isempty(STACK *stack){
    if(stack != NULL)
        return 0;
    return 1;
}


STACK *push(STACK *top, NODE *newNode){
    STACK *temp = (STACK*)malloc(sizeof(STACK));
    temp->dat = newNode;
    temp->pNext = top;
    return temp;
}

NODE *pop(STACK *stack){
    return stack->dat;

}

void read_all(STACK *stack){
    while(!isempty(stack)){
        NODE *temp = pop(stack);
        printf("%d: %s %d\n", temp->id, temp->name, temp->dat);
        stack = stack->pNext;
    }
}








